
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android自定义View实现角度选择器_Android / iVAN</title>

    <meta name="description" content="Android自定义View实现角度选择器_Android 首先来看一下Google Photos的效果 实现最终的效果: 实现思路 仔细观察这个效果,先分析构成结构,我把它分成三部分:     1.表示刻度的点     2.相应点上方的数字     3.控件中央的当前刻度与三角 可以看出,构成元素十分简单,不涉及图片,Drawable,那么只需要用Canvas画出来就好了. 接下来观察手势的操作,查看随着手指滑动,控件做出的变化,这里的变化有:      1.手指按上去时,部分区域变亮(部分区域即为可见区域)      2.随着手指滑动,相应的数字发生">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Android自定义View实现角度选择器_Android</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>首先来看一下Google Photos的效果</strong></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTE2MTExODAzOTY0LnBuZw==.jpg"></p>
<p><strong>实现最终的效果：</strong></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTE2MTExOTI2MDMxLmdpZg==.jpg"></p>
<p><strong>实现思路<br /></strong></p>
<p>仔细观察这个效果，先分析构成结构，我把它分成三部分：</p>
<p>    1、表示刻度的点</p>
<p>    2、相应点上方的数字</p>
<p>    3、控件中央的当前刻度与三角</p>
<p>可以看出，构成元素十分简单，不涉及图片，Drawable，那么只需要用Canvas画出来就好了。</p>
<p>接下来观察手势的操作，查看随着手指滑动，控件做出的变化，这里的变化有：</p>
<p>     1、手指按上去时，部分区域变亮（部分区域即为可见区域）</p>
<p>     2、随着手指滑动，相应的数字发生移动，当前角度值也发生改变</p>
<p>     3、离中心越近，透明度越低，且0°的下方的点要大一些</p>
<p>好了，我们对这个控件已经分析的很透彻了，根据分析，首先我们要在View的<code>onDraw()</code>方法中画出构成元素，之后要让它动起来，在<code>onTouchEvent()</code>方法中监听手势，改变一些值并重绘我们的View，这里很明显，我们要改变的肯定是当前角度这个值。</p>
<p><strong>动手</strong></p>
<p>既然有了思路，那么就要马上动手，不然下次忘记掉了怎么办？</p>
<p><strong>画点</strong></p>
<p>首先，先把点给画出来，位置很简单，肯定是从视图中心开始画，往左往右分别画点。</p>
<pre>
for (int i = 0; i &lt; mPointCount; i++) {
 canvas.getClipBounds(mCanvasClipBounds);
 canvas.drawPoint(mCanvasClipBounds.centerX() + (i - mPointCount / 2) * mPointMargin,
     mCanvasClipBounds.centerY(), mPointPaint);
}</pre>
<p>其中mPointCount为所要画的点个数，这里默认为51个，mPointMargin为两点间的边距，长度为View的宽度除以点的个数。</p>
<p>看看效果</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTE2MTEyMDU4ODE0LnBuZw==.jpg"></p>
<p>嗯，成功的把点给画出来了。</p>
<p><strong>画刻度上方的数字</strong></p>
<p>既然把点给画出来了，根据我们的思路，我们要把数字给画到正确的位置上，画数字当然很简单，这里难的是找到正确的位置。</p>
<p>首先，我们的数字是会移动的，随着当前角度的不同，所展示的数字大小位置都不同。但毫无疑问的是，这个位置（x坐标）肯定是关于当前角度的一个函数。至于具体是一个什么样的函数，相信聪明的你很快就可以分析出来，毕竟只是一个线性关系，这里就直接贴代码了。</p>
<pre>
private void drawDegreeText(int degrees, Canvas canvas, boolean canReach) {
 canvas.drawText(degrees + "°",
    getWidth() / 2 + mPointMargin * degrees / 2 - mTextWidths[0] / 2 * 3 - mCurrentDegrees / 2 * mPointMargin,
     getHeight() / 2 - 10,
     mTextPaint);
 }
}</pre>
<p>按照我们的效果，我们需要画出-90°~90°的刻度，其中-45°～45°是可到达角度，另外的角度不可到达。</p>
<pre>
drawDegreeText(0, canvas, true);
drawDegreeText(15, canvas, true);
drawDegreeText(30, canvas, true);
drawDegreeText(45, canvas, true);
drawDegreeText(-15, canvas, true);
drawDegreeText(-30, canvas, true);
drawDegreeText(-45, canvas, true);

drawDegreeText(60, canvas, false);
drawDegreeText(75, canvas, false);
drawDegreeText(90, canvas, false);
drawDegreeText(-60, canvas, false);
drawDegreeText(-75, canvas, false);
drawDegreeText(-90, canvas, false);</pre>
<p>好了，来看一下效果，可以看到，数字被画在了正确的位置。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTE2MTEyMTU3MzY0LnBuZw==.jpg"></p>
<p><strong>画当前角度</strong></p>
<p>这个超级简单呢，位置也特别好确定，上方三角形的Path也非常好知道，但是这里要注意的是，当当前角度为0°左右时，不应该把0°刻度显示出来。</p>
<pre>
//画当前角度
if (mCurrentDegrees &gt;= 10) {
 canvas.drawText(mCurrentDegrees + "°", getWidth() / 2 - mTextWidths[0], mBaseLine, mTextPaint);
} else if (mCurrentDegrees &lt;= -10) {
 canvas.drawText(mCurrentDegrees + "°", getWidth() / 2 - mTextWidths[0] / 2 * 3, mBaseLine, mTextPaint);
} else if (mCurrentDegrees &lt; 0) {
 canvas.drawText(mCurrentDegrees + "°", getWidth() / 2 - mTextWidths[0], mBaseLine, mTextPaint);
} else {
 canvas.drawText(mCurrentDegrees + "°", getWidth() / 2 - mTextWidths[0] / 2, mBaseLine, mTextPaint);
}

//三角指示器的Path
mIndicatorPath.moveTo(w / 2, h / 2 + mFontMetrics.top / 2 - 18);
mIndicatorPath.rLineTo(-8, -8);
mIndicatorPath.rLineTo(16, 0);</pre>
<p>还有一个小细节，就是离中心越近，其透明度越来越低，也就是说，我们要根据离中心的位置，来改变画笔Paint的alpha值，再将点画出。</p>
<pre>
 for (int i = 0; i &lt; mPointCount; i++) {

  if (i &gt; zeroIndex - 22 &amp;&amp; i &lt; zeroIndex + 22 &amp;&amp; mScrollStarted) {
   mPointPaint.setAlpha(255);
  } else {
   mPointPaint.setAlpha(100);
  }

  if (i &gt; mPointCount / 2 - 8 &amp;&amp; i &lt; mPointCount / 2 + 8
    &amp;&amp; i &gt; zeroIndex - 22 &amp;&amp; i &lt; zeroIndex + 22) {
   if (mScrollStarted)
    mPointPaint.setAlpha(Math.abs(mPointCount / 2 - i) * 255 / 8);
   else
    mPointPaint.setAlpha(Math.abs(mPointCount / 2 - i) * 100 / 8);
  }
  ……
 }</pre>
<p>这时，已经很像了，只是还不能动。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTE2MTEyMjUyOTcxLnBuZw==.jpg"></p>
<p><strong>动起来<br /></strong></p>
<p>该绘制的部分我们已经都绘制起来了，是时候让这个View动起来了，角度选择器的触摸事件不复杂，我们只需要在我们移动手指的时候根据滑动距离来改变当前角度值并重绘视图就可以看到移动效果了。为什么呢？因为我们之前在画数字的时候，位置都是由当前角度这个值决定的，所以它一发生变化，数字的位置也会发生改变。</p>
<pre>
@Override
public boolean onTouchEvent(MotionEvent event) {
 switch (event.getAction()) {
  ……
  case MotionEvent.ACTION_MOVE:
   float distance = event.getX() - mLastTouchedPosition;
   ……
   if (distance != 0) {
    onScrollEvent(event, distance);
   }
   break;
  }
  ……
  return true;
}

private void onScrollEvent(MotionEvent event, float distance) {
 mTotalScrollDistance -= distance;
 postInvalidate();
 mLastTouchedPosition = event.getX();
 mCurrentDegrees = (int) ((mTotalScrollDistance * mDragFactor) / mPointMargin);
 if (mScrollingListener != null) {
  mScrollingListener.onScroll(mCurrentDegrees);
 }
}</pre>
<p>当然你还需要处理一些细节性的东西，比如在数字移动的时候，靠近中心一定范围就会消失（透明度变为0），这些都是很容易控制的，只要改变画笔的透明度就好了，但是正是对细节的把控，才能做出一个效果让用户满意的自定义View。最后，再来看一下效果。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTE2MTEyMzM5OTMxLmdpZg==.jpg"></p>
<p><strong>扩展</strong></p>
<p>到这里，我们做的角度选择器已经和Google Photos的几乎一模一样了，但是，仅仅这样就够了。不，不够，我们还要继续扩展，为什么只能达到正负45°，我们要所有的范围自由选择，也就是-180°～180°，然后数字颜色啊，点的颜色啊都要让人自由选择。所以我们要扩展我们的角度选择器，把一切可以变化的接口暴露出来。</p>
<p>最后看一下我们多种多样的角度选择器，还是挺好看呀～</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTE2MTEyNDE4ODAzLmdpZg==.jpg"></p>
<p><strong>总结</strong></p>
<p>以上就是这篇文章的全部内容了，这次的自定义View相对于前两次的来说，无疑是简单了很多，只运用了最基础的绘图知识和事件机制，但是看起来效果也还不错哦，嘿嘿，反正我特别喜欢这个角度选择器，虽然我还不知道除了裁图页面可以用到还有哪里可以用到。所以说运用最简单的知识，也可以组合出比较复杂的效果，希望大家多发挥自己的想象力，一起自定义出更多好玩的，实用的，酷炫的控件吧。希望这篇文章对你有帮助，哪怕只是一些启发，也是值得的。如果有疑问大家也可以留言交流。</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索android<br />
                    ，                view<br />
                    ，                android选择器<br />
                                    滚动选择器<br />
                                    自定义view实现动画、自定义view实现滑动、自定义viewgroup实现、自定义view实现跑马灯、ios自定义时间选择器，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 03:11:49</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/android/" title="android">android</a>, <a href="https://www.iamivan.net/tag/view/" title="view">view</a>, <a href="https://www.iamivan.net/tag/%e6%bb%9a%e5%8a%a8%e9%80%89%e6%8b%a9%e5%99%a8/" title="滚动选择器">滚动选择器</a>, <a href="https://www.iamivan.net/tag/android%e9%80%89%e6%8b%a9%e5%99%a8/" title="android选择器">android选择器</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Android自定义View实现角度选择器_Android的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zV9xjnp.html" rel="bookmark">Android自定义View实现角度选择器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先来看一下Google Photos的效果 实现最终的效果: 实现思路 仔细观察这个效果,先分析构成结构,我把它分成三部分: 1.表示刻度的点 2.相应点上方的数字 3.控件中央的当前刻度与三角 可以看出,构成元素十分简单,不涉及图片,Drawable,那么只需要用Canvas画出来就好了. 接下来观察手势的操作,查看随着手指滑动,控件做出的变化,这里的变化有: 1.手指按上去时,部分区域变亮(部分区域即为可见区域) 2.随着手指滑动,相应的数字发生移动,当前角度值也发生改变 3.离中心越近,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqO23Kz.html" rel="bookmark">Android自定义View制作仪表盘界面&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 最近我跟自定义View杠上了,甚至说有点上瘾到走火入魔了.身为菜鸟的我自然要查阅大量的资料,学习大神们的代码,这不,前两天正好在郭神在微信公众号里推送一片自定义控件的文章--一步步实现精美的钟表界面.正适合我这种菜鸟来学习,闲着没事,我就差不多依葫芦画瓢也写了一个自定义表盘View,现在纯粹最为笔记记录下来.先展示下效果图: 下面进入正题 自定义表盘属性 老规矩,先在attrs文件里添加表盘自定义属性 &lt;declare-styleable name=&quot;WatchView&quot;&			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOkYZmz.html" rel="bookmark">Android自定义View实现打字机效果&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.先来看看效果演示 二.实现原理: 这个其实不难实现,通过一个定时器不断调用TextView的setText就行了,在setText的时候播放打字的音效. 具体代码如下: import java.util.Timer; import java.util.TimerTask; import android.content.Context; import android.media.MediaPlayer; import android.text.TextUtils; import android			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0BGRjz.html" rel="bookmark">Android自定义View编写随机验证码&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				很多的Android入门程序猿来说对于Android自定义View,可能都是比较恐惧的,但是这又是高手进阶的必经之路,所有准备在自定义View上面花一些功夫,多写一些文章.先总结下自定义View的步骤: 1.自定义View的属性 2.在View的构造方法中获得我们自定义的属性[ 3.重写onMesure ] 4.重写onDraw 我把3用[]标出了,所以说3不一定是必须的,当然了大部分情况下还是需要重写的. 1.自定义View的属性,首先在res/values/  下建立一个attrs.xml			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwK4Vmz.html" rel="bookmark">Android自定义View实现随机验证码&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				对于android开发来说自定义View还是一个比较重要的技能,所以在这里写一篇自定义View入门的文章,也是实现一个相对简单的随机产生验证码的功能: 自定义View主要也就分为几步 1.自定义View的属性  2.在我们的自定义的布局中获取自定义属性  3.重写onMesure方法  4.重写onDraw方法 好现在我们就一步一步的来,首先创建我们的View属性 在valuse目录下创建一个attrs.xml的文件,然后: &lt;?xml version=&quot;1.0&quot; encodin			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MR13rkb.html" rel="bookmark">Android自定义View实现拖动选择按钮&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文为大家分享了Android实现拖动选择按钮的具体代码,供大家参考,具体内容如下 效果图 View代码 第一步:自定义属性 &lt;declare-styleable name=&quot;DragView&quot;&gt; &lt;attr name=&quot;icon_drag&quot; format=&quot;reference&quot;/&gt; &lt;attr name=&quot;color_circle&quot; format=&quot;color&quot;/&gt; &			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3XO2kM.html" rel="bookmark">Android 自定义View的使用介绍&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在项目开发中,可能系统自带的一些widget不能满足我们的需求,这时就需要自定义View. 通过查看系统中的常用widget如Button,TextView,EditText,他们都继承自View,所以我们在继承自定义View的时候也自然的需要继承View.1.首先新建一个类LView继承自View 复制代码 代码如下: public class LView extends View { private Paint paint;  public LView(Context context) { 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKdeYAM.html" rel="bookmark">Android自定义View仿IOS圆盘时间选择器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				通过自定义view实现仿iOS实现滑动两端的点选择时间的效果 效果图 自定义的view代码 public class Ring_Slide2 extends View { private static final double RADIAN = 180 / Math.PI; private int max_progress; // 设置最大进度 private int cur_progress; //设置锚点1当前进度 private int cur_progress2; //设置锚点2进度 p			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPlOEZp.html" rel="bookmark">Android自定义VIew实现卫星菜单效果浅析&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 一 概述: 最近一直致力于Android自定义VIew的学习,主要在看&lt;android群英传&gt;,还有CSDN博客鸿洋大神和wing大神的一些文章,写的很详细,自己心血来潮,学着写了个实现了类似卫星效果的一个自定义的View,分享到博客上,望各位指点一二.写的比较粗糙,见谅.(因为是在Linux系统下写的,效果图我直接用手机拍的,难看,大家讲究下就看个效果,勿喷). 先来看个效果图,有点不忍直视: 自定义VIew准备: (1)创建继承自View的类; (2)重写构造函数; (3)定义属性. (			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkG0dp.html" rel="bookmark" class="title">如何在java中实现读取一个txt文档中的随机一行</a>
					<div>
						问题描述 如何在java中实现读取一个txt文档中的随机一行 如题,如何在java中实现读取一个txt文档中的随机一行? 主要就是怎么随机读取 解决方案 根据楼上的说法,来总结一下吧,总体来说,就是将 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bo05BM.html" rel="bookmark" class="title">冠群金辰中小企业信息安全解决方案</a>
					<div>
						据国家经贸委统计,中国各类中小企业数量超过1000万家;在国民经济中,60%的总产值来自于中小企业,并为社会提供了70%以上的就业机会.随着信息技术与网络应用的普及,越来越多中小企业业务对于信息技术的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYLPxb.html" rel="bookmark" class="title">JS在IE和Firefox之间的区别</a>
					<div>
						JS代码在IE和Firefox之间的区别,16个,非常实用. 1.    HTML 对象的 id 作为对象名的问题 IE:HTML 对象的 ID 可以作为 document 的下属对象变量名直接使用  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp80EBp.html" rel="bookmark" class="title">Photoshop图层链接</a>
					<div>
						链接 虽然我们已经知道了如何选择多个图层组合在一起移动,但是这种组合是临时性的.比如我们选择两个眼睛层一起移动后,又选择了其他图层,此时原先的临时组合就不存在了.以后如果要移动两个眼睛层,就必须再次选 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b2d4Bp.html" rel="bookmark" class="title">获得一个DataTable中的奇数行和偶数行</a>
					<div>
						   DataTable dt = GetData();   int count = dt.Rows.Count;    DataTable dt_jishu = new DataTable();   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYeVxM.html" rel="bookmark" class="title">Dreamweaver MX 2004视频宝典教程&lpar;121&rpar;</a>
					<div>
						dreamweaver|教程 第 121 集:制作&quot;信息分类区&quot;与页脚 课程目标:制作&quot;信息分类区&quot;与页脚 课程要点:使用Photoshop和Dreamweav ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7mVWM.html" rel="bookmark" class="title">sybase应用实例：葡萄牙Telecel移动电信公司</a>
					<div>
						商业挑战:通过改善客户服务和进行创新来成为葡萄牙移动通信的领先者.建立一个数据仓库详细地了解企业的经营状况,知道客户对什么感兴趣,他们在购买什么,哪些产品利润最大,销售渠道的效率如何,销售的地理分布差 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jmLVb.html" rel="bookmark" class="title">Vista系统中修改Hosts文件</a>
					<div>
						在WindowsVista中修改Hosts 文件或Lmhosts文件时,有可能会发生两种错误. 错误消息 1 拒绝访问 C:/Windows/System32/drivers/etc/ hosts 错 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKGD1p.html" rel="bookmark" class="title">ASP中Replace如何替换不区分大小写</a>
					<div>
						  我们先来看一看 Replace 的详细参数 描述 返回字符串,其中指定数目的某子字符串被替换为另一个子字符串. 语法 Replace(expression, find, replacewith[, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mywmqdz.html" rel="bookmark" class="title">win7如何创建系统恢复镜像&quest;</a>
					<div>
						  win7如何创建系统恢复镜像?如果win7纯净版系统遇到刺手无法解决的问题,可直接通过ghost备份还原就能回到之前的状态,其实win7系统自带有此功能,不必那么麻烦,下面小编教你如何在win7系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8Jarp.html" rel="bookmark" class="title">xcopy如何把本地文件复制到远程服务器</a>
					<div>
						xcopy如何把本地文件复制到远程服务器 1.net use IP地址 密码/user:****** 2.xcopy 文件 IP地址 批处理文件为backup.bat,其代码如下: ========= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6Ko0b.html" rel="bookmark" class="title">ec&colon;table checkbox 批量提交数据</a>
					<div>
						问题描述 ec:table checkbox 批量提交数据 ec:row /ec:row 请问:checkbox 批量选中一些行后,怎么将选中的person类对象批量传输到后台,后台如何得到?本人新手 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2Jmqb.html" rel="bookmark" class="title">linux发送邮件使用外部邮箱</a>
					<div>
						    一般Linux发送报警邮件通过本地邮箱或外部邮箱服务器,我习惯使用本地邮箱发邮件,装个Sendmail安装启动,即可实现发送邮件功能,但会存在两个问题: 1.发件人默认显示主机名,有的会被邮件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEqakp.html" rel="bookmark" class="title">iphone-如何自定义ios数字背景？</a>
					<div>
						问题描述 如何自定义ios数字背景? 如何自定义UITabBarItem的标记数字? 像这样的效果: 解决方案 用MKNumberBadgeView实现自定义的badgeView. 自定义UITabB ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRAWZp.html" rel="bookmark" class="title">10M宽带浏览器上网卡顿问题</a>
					<div>
						问题描述 10M宽带浏览器上网卡顿问题 描述: 我是租的房子,房东的宽带是10M的,房东说这电信安装的10m,给了账号密码.后来经过**测试确实是10M**. 现在情况是这样的,初次打开一个**页面加 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEExkM.html" rel="bookmark" class="title">《拥抱机器人时代&mdash;&mdash;Servo杂志中文精华合集》&mdash;&mdash;4&period;7 理解智能应用</a>
					<div>
						4.7 理解智能应用 数据要变得有用,必须要有利用它的能力.这可以是通过专门分析数据的人员手工来实现并做出相应的决策的.但是建立一个以人为中心的过程是不符合当前的技术趋势的,因为期望是每个操作都是由某 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8AV4lz.html" rel="bookmark" class="title">江南会：马云的神秘私家会所</a>
					<div>
						江南会位于西湖边,占地十亩.是马云.冯根生.沈国军.宋卫平.鲁伟鼎.陈天桥.郭广昌.丁磊八位浙商共同发起创办的一家私人会所.著名建筑家艾未未将7幢旧式祠堂和民居改建,才成为现在的这个园林式会所,而馆名 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYKO5p.html" rel="bookmark" class="title">为什么要进行视频营销&quest;</a>
					<div>
						为什么要进行网络营销?因为越来越多的消费者出现在网络上.为什么要进行视频营销?因为最受欢迎的节目资源和创新的营销方式出现在视频领域. 对于快销品来说,以前主要的营销预算投放是电视这样的传统大众媒体.但 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5EklM.html" rel="bookmark" class="title">Exchange 2007 防垃圾邮件问题</a>
					<div>
						问题描述 关于这个邮件数据流我还一直没有弄明白,数据流出去的时候是经过集线器--&gt;Edge然后出外网,那么邮件流进来的时候也要经过Edge才能起到过滤的作用.那么这样的话,公司的IP(mail. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyevmJM.html" rel="bookmark" class="title">H3C S2100配置管理vlan与交换机管理IP</a>
					<div>
						管理 VLAN 简介: S2100系列以太网交换机任何时刻只能有一个VLAN对应的VLAN接口可以配置IP地址, 该 VLAN 即为管理 VLAN. 如果要对以太网交换机进行远程管理,必须配置交换机管 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M126Aop.html" rel="bookmark" class="title">有道云笔记与腾讯微博展开合作 重要微博一键存云端</a>
					<div>
						近日,有道云笔记与腾讯微博达成合作,通过接入有道云笔记开放接口,用户可在腾讯微博上将重要微博一键分享到有道云笔记中,在电脑.手机等多个设备终端随时随地查看.据了解,这是腾讯微博首次将微博分享功能开放给 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjOZ8M.html" rel="bookmark" class="title">微软已面向零售商售出了超过500万台Xbox One游戏主机</a>
					<div>
						微软周四宣布,自去年11月面市以来,已面向零售商售出了超过500万台Xbox One游戏主机.今年1月,微软表示,截至2013年底,Xbox One的销量已经超过了300万台.Xbox One于去年1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnPRaM.html" rel="bookmark" class="title">activity-c语言字符定义数组问题</a>
					<div>
						问题描述 c语言字符定义数组问题 题目中给出一个元素为n的字符数组,却又不能定义为n,并且还要判断数组长度是否符合要求,请问如何定义,并且如何判断长度,谢了 解决方案 #include &lt;str ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1NNerp.html" rel="bookmark" class="title">PHP入门速成&lpar;3&rpar;&lowbar;php基础</a>
					<div>
						小结 通过以上三步,我们使用PHP快速地在单一页面上实现了表单显示和表单处理的功能. 设定Cookies PHP提供了强大的设定和读取Cookies的功能.在此,我们不想对Cookies进行过多的介绍 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmXR8p.html" rel="bookmark" class="title">Android微信自动抢红包插件优化和实现&lowbar;Android</a>
					<div>
						又是兴趣系列 网上有很多自动强红包的例子和代码,笔者也是做了一些优化. 先说说自己的两个个优势 1.可以在聊天界面自动强不依赖于通知栏推送 2.可以在屏幕熄灭的时候的时候点亮屏幕自动抢(目前只测过fl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDkxaKp.html" rel="bookmark" class="title">YouTube正式出台与个人用户共享计划</a>
					<div>
						北京时间5月6日消息,据国外媒体报道,Google近日通过企业博客宣布,将同个人视频提供者共享视频生成的广告营收.不过,这一政策并不适用于每一个人. 在YouTube之前,视频共享网站Revver已经 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYO01b.html" rel="bookmark" class="title">oracle中Direct IO&plus;asm引起css initialization</a>
					<div>
						某数据库升级到12c后(应用代码也升级了),出现了大量css initialization的等待: SQL&gt; select event,sql_id,count(*) from  v$sessi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8GkxNM.html" rel="bookmark" class="title">最长用最基本的MSSQL数据库备份与还原&lowbar;MsSql</a>
					<div>
						一.备份数据库  1.打开SQL企业管理器,在控制台根目录中依次点开Microsoft SQL Server 2.SQL Server组--&gt;双击打开你的服务器--&gt;双击打开数据库目录 3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7w4Waz.html" rel="bookmark" class="title">苹果为iTunes音乐会推免费直播应用</a>
					<div>
						iTunes Live流媒体直播应用 新浪科技讯 北京时间6月22日早间消息,苹果周二发布了一款免费iOS应用,该应用可以对&lt;2011伦敦iTunes音乐嘉年华&gt;(iTunes Festi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQW4Qrp.html" rel="bookmark" class="title">SA：美国引领BYOD的实施，欧盟国家态度谨慎</a>
					<div>
						几年来,BYOD(自带设备办公)不仅仅只代表者员工移动性--从用户携带自己的设备在各地灵活办公到一个节省开支的工具:把公司拥有的设备替换成员工的个人设备.BYOD的施行比传统的企业采购更经济,同时还提 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
